package com.example;

import io.undertow.server.handlers.CookieImpl;
import io.undertow.servlet.spec.HttpServletRequestImpl;
import io.undertow.servlet.spec.HttpServletResponseImpl;
import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Servlet implementation class Servlet1
 */
@WebServlet("/servlet1")
public class Servlet1 extends HttpServlet {

    private static final long serialVersionUID = 1L;

    /**
     * @see HttpServlet#HttpServlet()
     */
    public Servlet1() {
        super();
    }

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        HttpSession session = request.getSession();

        ServletContext webApp1 = getServletContext();
        ServletContext webApp2 = webApp1.getContext("/webapp2");
        
        if (session.isNew()) {
            session.setAttribute("WEBAPP_CONTEXT_PATH", webApp1.getContextPath());
        }

        request.setAttribute("WEBAPP1_SESSION", session);

        RequestDispatcher crossContextDispatcher = webApp2.getRequestDispatcher("/servlet2");
        if ("include".equals(request.getParameter("op"))) {
            System.err.println("Includying to cross-context: " + crossContextDispatcher);
            crossContextDispatcher.include(request, response);
        } else {
            System.err.println("Forwarding to cross-context: " + crossContextDispatcher);
            crossContextDispatcher.forward(request, response);
        }
    }

}
